
// *****************************************************************
//   AD5302 
// AS-kit
//  : 15.04.2019
// *****************************************************************

#include "Kernel.h"
#include "DAC.h"

//   
#ifdef DAC_ASMEGA_M
#define	DAC_SYNC	7	//PB7
#define	DAC_LDAC	6	//PB6
#endif

#define sync_low() PORTB &= ~(1<<DAC_SYNC)
#define sync_high() PORTB |= (1<<DAC_SYNC)

#define ldac_low() PORTB &= ~(1<<DAC_LDAC)
#define ldac_high() PORTB |= (1<<DAC_LDAC)

inline void spi_write(byte data)
{
	SPDR = data;
	while(!(SPSR & (1<<SPIF)))
		;
}

void DAC_Open(void)
{
	//  
	PORTB |= (1<<DAC_SYNC) | (1<<DAC_LDAC) | (1<<2) | (1<<1);
	DDRB |= (1<<DAC_SYNC) | (1<<DAC_LDAC) | (1<<2) | (1<<1);

	//   LDAC
	ldac_low();

	// SPI Init
	SPCR = 0b01011000;
	SPSR = 0b00000000;
}


void DAC_WriteA(byte data)
{
	word result = 0;

	result = (((word)data) << 4);

	sync_low();

	spi_write(result >> 8);
	spi_write(result);

	sync_high();
	
}

void DAC_WriteB(byte data)
{
	word result = 0;
	result = ((((word)data) << 4) | 0x8000);

	sync_low();
  
	spi_write(result >> 8);
	spi_write(result);

	sync_high();
}