// *****************************************************************
//  USART,  
// AS-kit
//  : 15.04.2019
// *****************************************************************

#ifndef USART_H
#define USART_H

typedef enum
{
	XTAL_7372800 = 0,
	XTAL_8000000 = 1,
	XTAL_11059200 = 2,  
	XTAL_14745600 = 3,
	XTAL_16000000 = 4
} XTAL_FREQ;

typedef enum
{
	BR_2400 = 0,
	BR_4800 = 1,
	BR_9600 = 2,
	BR_14400 = 3,
	BR_19200 = 4,
	BR_28800 = 5,
	BR_38400 = 6,
	BR_57600 = 7,
	BR_76800 = 8,
	BR_115200 = 9
} BAUD_RATE;

typedef enum
{
	CHAR_SIZE_5BIT = 0,
	CHAR_SIZE_6BIT = 1,
	CHAR_SIZE_7BIT = 2,
	CHAR_SIZE_8BIT = 3
} CHAR_SIZE;

typedef enum
{
	PARITY_DISABLED = 0,
	PARITY_EVEN = 2,
	PARITY_ODD = 3
} PARITY;

typedef enum
{
	ONE_STOP_BIT = 0,
	TWO_STOP_BITS = 1
} STOP_BITS;

void USART0_Open(
	XTAL_FREQ XtalFreq,
    BAUD_RATE BaudRate,
    CHAR_SIZE CharSize,
    PARITY Parity,
    STOP_BITS StopBits);
void USART0_Close(void);

unsigned char USART0_Read(void);
void USART0_Write(unsigned char b);
void USART0_WriteWord(unsigned int data);
void USART0_WriteDWord(unsigned long data);
void USART0_WriteString(char* string);
void USART0_WriteInt(unsigned int value);

unsigned char USART0_IsData(void);
void USART0_Purge(void);
void USART0_Flush(void);

void USART1_Open(
	XTAL_FREQ XtalFreq,
    BAUD_RATE BaudRate,
    CHAR_SIZE CharacterSize,
    PARITY Parity,
    STOP_BITS StopBits);
void USART1_Close(void);

unsigned char USART1_IsData(void);

unsigned char USART1_Read(void);
void USART1_Write(unsigned char b);
unsigned char USART1_IsData(void);
void USART1_Purge(void);
void USART1_Flush(void);
void USART1_WriteWord(unsigned int data);
void USART1_WriteDWord(unsigned long data);
void USART1_WriteString(char* string);
void USART1_WriteInt(unsigned int value);

#endif