// *****************************************************************
//  
// AS-kit
//  : 15.04.2019
// *****************************************************************

#include "Kernel.h"
#include "LCD.h"
#include <stdlib.h>
#include <string.h>

/*
    'kernel.h'
    4- 

#undef LCD_USE_4BIT_INTERFACE

#define LCD_LINES			2
#define LCD_COLUMNS			16
#define LCD_PATTERN_HEIGHT	8

#define LCD_DATA_PORT   PORTC
#define LCD_DATA_PINS   PINC
#define LCD_DATA_DDR    DDRC
#define LCD_EN_DDR      DDRA
#define LCD_RS_DDR      DDRA
#define LCD_RW_DDR      DDRA
#define LCD_EN_PORT     PORTA
#define LCD_RS_PORT     PORTA
#define LCD_RW_PORT     PORTA
#define LCD_EN_PIN      BIT7
#define LCD_RS_PIN      _BV(5)
#define LCD_RW_PIN      _BV(6)

OR simply

#define LCD_ASMEGA_M
#define LCD_ASMEGA_PLD
*/

#ifdef LCD_ASMEGA_M

#define LCD_DATA_PORT   PORTA
#define LCD_DATA_PINS   PINA
#define LCD_DATA_DDR    DDRA
#define LCD_EN_DDR      DDRE
#define LCD_RS_DDR      DDRC
#define LCD_RW_DDR      DDRC
#define LCD_EN_PORT     PORTE
#define LCD_RS_PORT     PORTC
#define LCD_RW_PORT     PORTC
#define LCD_EN_PIN      _BV(2)
#define LCD_RS_PIN      _BV(6)
#define LCD_RW_PIN      _BV(5)

#endif


#ifdef LCD_ASMEGA_PLD

#define LCD_DATA_PORT   PORTC
#define LCD_DATA_PINS   PINC
#define LCD_DATA_DDR    DDRC
#define LCD_EN_DDR      DDRA
#define LCD_RS_DDR      DDRA
#define LCD_RW_DDR      DDRA
#define LCD_EN_PORT     PORTA
#define LCD_RS_PORT     PORTA
#define LCD_RW_PORT     PORTA
#define LCD_EN_PIN      _BV(7)
#define LCD_RS_PIN      _BV(5)
#define LCD_RW_PIN      _BV(6)

#endif

#define SET_LCD_PORT_OUTPUT LCD_DATA_DDR = 0xFF
#define SET_LCD_PORT_INPUT  LCD_DATA_DDR = 0x00

#define SET_LCD_E       LCD_EN_PORT |= LCD_EN_PIN
#define CLEAR_LCD_E     LCD_EN_PORT &= ~LCD_EN_PIN

#define SET_LCD_DATA    LCD_RS_PORT |= LCD_RS_PIN
#define SET_LCD_CMD     LCD_RS_PORT &= ~LCD_RS_PIN

#define SET_LCD_READ    LCD_RW_PORT |= LCD_RW_PIN
#define SET_LCD_WRITE   LCD_RW_PORT &= ~LCD_RW_PIN

#define LCD_ON           0b00001100   

#define LCD_CURS_ON      0b00001111
#define LCD_CURS_OFF     0b00001100
#define LCD_CURS_STATIC  0b00001110
#define LCD_OFF          0b00001000
#define LCD_HOME         0b00000010  
#define LCD_CLEAR        0b00000001

#define LCD_INIT_BY_INSTR   0b00110000
#define LCD_MODE_SET        0b00000110

#ifdef LCD_USE_4BIT_INTERFACE
	#define LCD_INIT          0b00100000
	#define LCD_FUNCTION_SET  0b00101000
#else
	#define LCD_INIT          0b00110000
	#define LCD_FUNCTION_SET  0b00111000
#endif

// extern

byte LCD_X = 0, LCD_Y = 0;

// static variables

byte LCD_Buffer[2][LCD_LINES*LCD_COLUMNS];
char LCD_TempBuffer[16];
bool LCD_Blink = false;
byte LCD_CursorStateByte = LCD_CURS_OFF;
bool LCD_SomeBlinked = false;

 //    
byte rus_table[64] =
{
//                                                               
	0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8,
//                                                               
	0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,0x62,0xAF,0xB0,0xB1,
//                                                               
	0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE,
//                                                               
	0x70,0x63,0xBF,0x79,0xE4,0x78,0xE5,0xC0,0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7
};

//  

byte LCD_IsBusy(void)
{
	byte temp;
	#ifdef _SIMULATE_
	return false;
	#else
	SET_LCD_PORT_INPUT;
	CLEAR_LCD_E;
	SET_LCD_READ;
	SET_LCD_CMD;
	SET_LCD_E;
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");
	temp = LCD_DATA_PINS; // Load data from port
	CLEAR_LCD_E;
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");
#ifdef LCD_USE_4BIT_INTERFACE
	SET_LCD_E;
	asm("nop");asm("nop");asm("nop");asm("nop");
	CLEAR_LCD_E;
#endif
	if(temp & 0b10000000)
		return true;
	else
		return false;
	#endif
}

void LCD_Write8(byte data) //    , 8- 
{
	SET_LCD_PORT_OUTPUT;
	LCD_DATA_PORT = data;
	SET_LCD_E;
	asm("nop");asm("nop");asm("nop");asm("nop");
	CLEAR_LCD_E;
}

void LCD_Write4(byte data)
{
	SET_LCD_PORT_OUTPUT;
	asm("nop");asm("nop");asm("nop");asm("nop");
	
	// Transmit high quad
	LCD_DATA_PORT = (data & 0xF0);
	asm("nop");asm("nop");asm("nop");asm("nop");
	SET_LCD_E;
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");asm("nop");asm("nop");asm("nop");
	CLEAR_LCD_E;
	
	// Wait
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");
	
	// Transmit low quad
	LCD_DATA_PORT = (data << 4) & 0xF0;
	asm("nop");asm("nop");asm("nop");asm("nop");
	SET_LCD_E;
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");
	CLEAR_LCD_E;
}

void LCD_WriteControl(byte cmd) //     
{
	#ifdef LCD_USE_POLLING
	while(LCD_IsBusy())
		;
	#else
	Delay(1);
	#endif
	
	CLEAR_LCD_E;
	SET_LCD_WRITE;
	SET_LCD_CMD;
#ifdef LCD_USE_4BIT_INTERFACE
    LCD_Write4(cmd);
#else
    LCD_Write8(cmd);
#endif
}

void LCD_WriteControl8(byte cmd) //      ( 8- )
{
	#ifdef LCD_USE_POLLING
	while(LCD_IsBusy())
		;
	#else
	Delay(1);
	#endif

	CLEAR_LCD_E;
	SET_LCD_WRITE;
	SET_LCD_CMD;
	LCD_Write8(cmd);
}

void LCD_WriteData(byte data) //     
{
	#ifdef LCD_USE_POLLING
	while(LCD_IsBusy())
		;
	#else
	Delay(1);
	#endif
	
	CLEAR_LCD_E;
	SET_LCD_WRITE;
	SET_LCD_DATA;
#ifdef LCD_USE_4BIT_INTERFACE
    LCD_Write4(data);
#else
    LCD_Write8(data);
#endif
}

void LCD_Clear(void)
{
	LCD_WriteControl(LCD_CLEAR);
}

byte StringOffset[4] = { 0x80, 0xc0, 0x94, 0xd4 };

void LCD_Cursor(byte LCD_X, byte LCD_Y)
{
	LCD_WriteControl(StringOffset[LCD_Y] + LCD_X);
}

//  

void LCD_Init(void) //   
{
	SET_LCD_PORT_OUTPUT;
	LCD_EN_DDR |= LCD_EN_PIN;
	LCD_RS_DDR |= LCD_RS_PIN;
	LCD_RW_DDR |= LCD_RW_PIN;
	CLEAR_LCD_E;
	SET_LCD_CMD;
	SET_LCD_WRITE;
#ifndef _SIMULATE
	Delay(20);
	LCD_Write8(LCD_INIT_BY_INSTR);
	Delay(5);
	LCD_Write8(LCD_INIT_BY_INSTR);
	Delay(1);
	LCD_Write8(LCD_INIT_BY_INSTR);
	Delay(1);
	LCD_Write8(LCD_INIT);
	Delay(1);
	LCD_WriteControl(LCD_FUNCTION_SET);
	LCD_WriteControl(LCD_ON);
	LCD_WriteControl(LCD_MODE_SET);
	LCD_WriteControl(LCD_CLEAR);
	LCD_Cursor(0,0);
	Delay(1);
#endif
}

void LCD_ReWrite(byte Pane)
{
	byte* ptr;
	byte i,j;

	if(!Pane)
		ptr = LCD_Buffer[0];
	else
		ptr = LCD_Buffer[1];

	for(i = 0; i < LCD_LINES; i++)
	{
		LCD_Cursor(0,i);
		for(j = 0; j < LCD_COLUMNS; j++)
	    	LCD_WriteData(*ptr++);
	}
}

//   

void LCD_ClearBuf()
{
	LCD_SomeBlinked = false;
	memset(LCD_Buffer,' ',LCD_LINES*LCD_COLUMNS*2);
	LCD_X = LCD_Y = 0;
	LCD_Blink = false;
}

void LCD_SetBlink(void)
{
	LCD_Blink = true;
	LCD_SomeBlinked = true;
}

void LCD_SetNoBlink(void)
{
	LCD_Blink = false;
}

void LCD_SetBlinkTo(bool b)
{
	LCD_Blink = b;
}

void LCD_SetPos(byte X, byte Y)
{
	LCD_X = X;
	LCD_Y = Y;
}

byte CursorStateBytes[4] = { LCD_CURS_OFF, LCD_CURS_ON, LCD_CURS_STATIC };

void LCD_SetCursorState(LCD_CURSOR_STATE CursorState)
{
	LCD_CursorStateByte = CursorStateBytes[CursorState&3];
}

word Phase = 0; 

#define PHASE_BLINK 100
#define PHASE_FULL 160

void LCD_StartBlink(void)
{
	Phase = PHASE_BLINK;
}

void LCD_RestartBlink(void)
{
	Phase = 0;
}

void LCD_Refresh(void)
{
	LCD_ReWrite(Phase >= PHASE_BLINK);
	if(LCD_CursorStateByte != LCD_CURS_OFF)
	{
		if(LCD_Y < LCD_LINES && LCD_X < LCD_COLUMNS)
			LCD_Cursor(LCD_X,LCD_Y);
		else
			LCD_Cursor(LCD_COLUMNS-1,LCD_LINES-1);
		LCD_WriteControl(LCD_CursorStateByte);
	}
	else
		LCD_WriteControl(LCD_CURS_OFF);
}

void LCD_OnIdle(word Ticks)
{
	bool S1, S2;
	S1 = (Phase >= PHASE_BLINK);
	Phase += Ticks;
	while(Phase >= PHASE_FULL)
		Phase -= PHASE_FULL;
	S2 = (Phase >= PHASE_BLINK);
	if(LCD_SomeBlinked && S1 != S2)
		LCD_Refresh();
}

void LCD_WriteChar(byte c)
{
	byte Position;
	if(LCD_Y < LCD_LINES && LCD_X < LCD_COLUMNS)
	{
		if(c >= 0xc0)
			c = rus_table[c - 0xc0];
		else if(c == '')
			c = 0xb5;
		else if(c == '')
			c = 0xa2;
		Position = LCD_COLUMNS*LCD_Y + LCD_X;
		LCD_Buffer[0][Position] = c;
		if(LCD_Blink)
			LCD_Buffer[1][Position] = ' ';
		else
			LCD_Buffer[1][Position] = c;
		LCD_X++;
		if(LCD_X >= LCD_COLUMNS)
			LCD_X = 0, LCD_Y++;
	}
}

void LCD_WriteByteHex(byte c)
{
	LCD_WriteChar(HEX[(c>>4)&0x0f]);
	LCD_WriteChar(HEX[c&0x0f]);
}

void LCD_WriteWordHex(word c)
{
	LCD_WriteChar(HEX[(c>>12)&0x0f]);
	LCD_WriteChar(HEX[(c>>8)&0x0f]);
	LCD_WriteChar(HEX[(c>>4)&0x0f]);
	LCD_WriteChar(HEX[c&0x0f]);
}

void LCD_WriteDwordHex(dword c)
{
	LCD_WriteChar(HEX[(c>>28)&0x0f]);
	LCD_WriteChar(HEX[(c>>24)&0x0f]);
	LCD_WriteChar(HEX[(c>>20)&0x0f]);
	LCD_WriteChar(HEX[(c>>16)&0x0f]);
	LCD_WriteChar(HEX[(c>>12)&0x0f]);
	LCD_WriteChar(HEX[(c>>8)&0x0f]);
	LCD_WriteChar(HEX[(c>>4)&0x0f]);
	LCD_WriteChar(HEX[c&0x0f]);
}

void LCD_WriteByteBinary(byte c)
{
 	byte i;
	for(i = 0; i < 8; i++)
	{
	 if(c & 0x80)
	 LCD_WriteChar('1');
	 else
	 LCD_WriteChar('0');
	 c <<= 1;
	 }
}

void LCD_WriteWordBinary(word c)
{
 	byte i;
	for(i = 0; i < 16; i++)
	{
	 if(c & 0x8000)
	 LCD_WriteChar('1');
	 else
	 LCD_WriteChar('0');
	 c <<= 1;
	 }
}

void LCD_WriteDwordBinary(dword c)
{
 	byte i;
	for(i = 0; i < 32; i++)
	{
	 if(c & 0x80000000)
	 LCD_WriteChar('1');
	 else
	 LCD_WriteChar('0');
	 c <<= 1;
	 }
}

void LCD_WriteString(char* String)
{
	byte Position = LCD_COLUMNS*LCD_Y + LCD_X;
	byte c;

	while(*String)
	{
		c = *String;
		String++;

		if(c >= 0xc0)
			c = rus_table[c - 0xc0];
		else if(c == '')
			c = 0xb5;
		else if(c == '')
			c = 0xa2;

		if(LCD_Y < LCD_LINES && LCD_X < LCD_COLUMNS)
		{
			LCD_Buffer[0][Position] = c;
			if(LCD_Blink)
				LCD_Buffer[1][Position] = ' ';
			else
				LCD_Buffer[1][Position] = c;
			LCD_X++;
			Position++;
			if(LCD_X >= LCD_COLUMNS)
			{
				LCD_X = 0;
				LCD_Y++;
				Position = LCD_COLUMNS*LCD_Y;
			}
		}
	}
}

void LCD_WriteBuffer(byte* String, byte Count)
{
	byte Position = LCD_COLUMNS*LCD_Y + LCD_X;
	byte c;
	byte i;

	for(i = 0; i < Count; i++)
	{
		c = *String;
		String++;

		if(c >= 0xc0)
			c = rus_table[c - 0xc0];
		else if(c == '')
			c = 0xb5;
		else if(c == '')
			c = 0xa2;
		if(LCD_Y < LCD_LINES && LCD_X < LCD_COLUMNS)
		{
			LCD_Buffer[0][Position] = c;
			if(LCD_Blink)
				LCD_Buffer[1][Position] = ' ';
			else
				LCD_Buffer[1][Position] = c;
			LCD_X++;
			Position++;
			if(LCD_X >= LCD_COLUMNS)
			{
				LCD_X = 0, LCD_Y++;
				Position = LCD_COLUMNS*LCD_Y;
			}
		}
	}
}

void LCD_WriteInt00(byte Number)
{
	byte c = '0';
	while(Number >= 10)
	{
		c++;
		Number -= 10;
	}
	LCD_WriteChar(c);
	LCD_WriteChar(Number+'0');
}

void LCD_WriteInt(word Number)
{
	itoa(Number,LCD_TempBuffer,10);
	LCD_WriteString(LCD_TempBuffer);
}

void LCD_WriteSignedInt(int Number)
{
	if(Number >= 0)
		itoa(Number,LCD_TempBuffer,10);
	else
	{
		LCD_TempBuffer[0] = '-';
		itoa(-Number,LCD_TempBuffer+1,10);
	}
	LCD_WriteString(LCD_TempBuffer);
}

void LCD_WriteLong(dword Number)
{
	ltoa(Number,LCD_TempBuffer,10);
	LCD_WriteString(LCD_TempBuffer);
}

void LCD_WriteTimeMMSS(dword sec)
{
	word minutes = (sec/60)%60;
	byte seconds = sec%60;
	LCD_WriteInt00(minutes);
	LCD_WriteChar(':');
	LCD_WriteInt00(seconds);
}

void LCD_WriteTimeHHMM(dword sec)
{
	dword hours = (sec/(60*60))%24;
	byte minutes = (sec/60)%60;
	LCD_WriteInt00(hours); 
	LCD_WriteChar(':');
	LCD_WriteInt00(minutes);
}
 //       
void LCD_WriteTimeHHMMSS(dword sec)
{
	dword hours = (sec/(60*60))%24;
	byte minutes = (sec/60)%60;
	byte seconds = sec % 60;
	LCD_WriteInt00(hours); 
	LCD_WriteChar(':');
	LCD_WriteInt00(minutes);
	LCD_WriteChar(':');
	LCD_WriteInt00(seconds);
	LCD_WriteChar(' ');		//     
	LCD_WriteChar(' ');
	LCD_WriteChar(' ');
	LCD_WriteChar(' ');
	LCD_WriteChar(' ');
}

void LCD_ScrollUp(void)
{
	byte t,i;
	for(t = 0; t < 2; t++)
		for(i = 0; i < LCD_COLUMNS*(LCD_LINES-1); i++)
			LCD_Buffer[t][i] = LCD_Buffer[t][i+LCD_COLUMNS];
	for(t = 0; t < 2; t++)
		for(i = 0; i < LCD_COLUMNS; i++)
			LCD_Buffer[t][i+(LCD_LINES-1)*LCD_COLUMNS] = ' ';
}

//       
void LCD_WriteCharConsole(byte c)
{
	byte Position;

	if(LCD_X >= LCD_COLUMNS)
	{
		LCD_X = 0;
		LCD_Y++;
		while(LCD_Y >= LCD_LINES)
		{
			LCD_ScrollUp();
			LCD_Y--;
		}
	}

	if(c >= 0xc0)
		c = rus_table[c - 0xc0];
	else if(c == '')
		c = 0xb5;
	else if(c == '')
		c = 0xa2;

	if(c == '\n' || c == '\r')
	{
		LCD_X = 0;
		LCD_Y++;
		while(LCD_Y >= LCD_LINES)
		{
			LCD_ScrollUp();
			LCD_Y--;
		}
	}
	else if(c == '\b')
	{
		if(LCD_X)
		{
			LCD_X--;
			Position = LCD_COLUMNS*LCD_Y + LCD_X;
			LCD_Buffer[0][Position] = LCD_Buffer[1][Position] = ' ';
		}
	}
	else if(c >= ' ')
	{
		Position = LCD_COLUMNS*LCD_Y + LCD_X;
		LCD_Buffer[0][Position] = c;
		if(LCD_Blink)
			LCD_Buffer[1][Position] = ' ';
		else
			LCD_Buffer[1][Position] = c;
		LCD_X++;
		if(LCD_X >= LCD_COLUMNS)
		{
			LCD_X = 0;
			LCD_Y++;
			while(LCD_Y >= LCD_LINES)
			{
				LCD_ScrollUp();
				LCD_Y--;
			}
		}
	}
	LCD_Refresh();
}

void LCD_WriteConsole(char* String)
{
	byte Position;
	byte i, c;

	if(LCD_X >= LCD_COLUMNS)
	{
		LCD_X = 0;
		LCD_Y++;
		while(LCD_Y >= LCD_LINES)
		{
			LCD_ScrollUp();
			LCD_Y--;
		}
	}

	for(i = 0; true; i++)
	{
		c = String[i];
		if(!c)
		{
			LCD_Refresh();
			return;
		}
		
		if(c >= 0xc0)
			c = rus_table[c - 0xc0];
		else if(c == '')
			c = 0xb5;
		else if(c == '')
			c = 0xa2;

		if(c == '\n' || c == '\r')
		{
			LCD_X = 0;
			LCD_Y++;
			while(LCD_Y >= LCD_LINES)
			{
				LCD_ScrollUp();
				LCD_Y--;
			}
		}
		else if(c == '\b')
		{
			if(LCD_X)
			{
				LCD_X--;
				Position = LCD_COLUMNS*LCD_Y + LCD_X;
				LCD_Buffer[0][Position] = LCD_Buffer[1][Position] = ' ';
			}
		}
		else if(c >= ' ')
		{
			Position = LCD_COLUMNS*LCD_Y + LCD_X;
			LCD_Buffer[0][Position] = c;
			if(LCD_Blink)
				LCD_Buffer[1][Position] = ' ';
			else
				LCD_Buffer[1][Position] = c;
			LCD_X++;
			if(LCD_X >= LCD_COLUMNS)
			{
				LCD_X = 0;
				LCD_Y++;
				while(LCD_Y >= LCD_LINES)
				{
					LCD_ScrollUp();
					LCD_Y--;
				}
			}
		}
	}
}

 //        
void LCD_ModifyCharacter(byte *data, byte address)
{
	byte i;
	// Set CGRAM address
	LCD_WriteControl((address<<3) | 0b01000000);
	for (i=0; i < LCD_PATTERN_HEIGHT; i++)
		LCD_WriteData(data[i] & 0b00011111); //   5*LCD_PATTERN_HEIGHT
}

